-- This file is a part of Avoision.
-- 
-- Copyright (C) 2012 Jared Krinke.
-- 
-- Avoision is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

require("UI/Input.lua")
require("UI/FormLayer.lua")
require("Settings/Controls.lua")

Common = {
    version = "1.1",
    textWidth = 15,
    textHeight = 30,
}

Form.setDefaultTextSize(Common.textWidth, Common.textHeight)

-- Controls
Common.logicalEvents = {
    up = { necessary = true },
    down = { necessary = true },
    left = { necessary = true },
    right = { necessary = true },
    activate = { necessary = true },
    delete = { },
    cancel = { },
}

Common.input = Input.new(Common.logicalEvents, controlsData)
FormLayer.setDefaultInput(Common.input)

-- Set up difficulty levels
Common.difficultyLevelNames = {
    "Easy",
    "Normal",
    "Hard",
    "Extreme",
}

Common.difficultyLevel = { }

local v = 1
while v <= #Common.difficultyLevelNames do
    Common.difficultyLevel[Common.difficultyLevelNames[v]] = v

    v = v + 1
end

-- Collision detection
Common.group = {
    player  = 1,
    goal    = 2,
    enemy   = 3,
}

Common.playerColor = Color.new(0, 1, 0)
Common.goalColor   = Color.new(1, 0, 0)
Common.enemyColor  = Color.new(1, 1, 1)

Common.squareMesh = Mesh.new()
Common.squareMesh:addTriangle(-0.5, 0.5, -0.5, -0.5, 0.5, 0.5)
Common.squareMesh:addTriangle(0.5, 0.5, -0.5, -0.5, 0.5, -0.5)

Common.seekerMesh = Mesh.new()
Common.seekerMesh:addTriangle(0.5, 0, -0.218, 0.5, -0.218, -0.5)
Common.seekerMesh:addTriangle(-0.218, 0.5, -0.5, 0.5, -0.5, -0.5)
Common.seekerMesh:addTriangle(-0.218, -0.5, -0.218, 0.5, -0.5, -0.5)

